import 'package:web_template/database/database_core.dart';
import 'package:flutter/material.dart';
import 'package:hive_flutter/hive_flutter.dart';

class AppCore {
  ValueNotifier<ThemeMode> themeModeNotifier = ValueNotifier(ThemeMode.system);
  Database database = Database();
  AppCore();

  Future<void> ensureInitialized() async {
    await database.ensureInitialized();
    themeModeNotifier = ValueNotifier(
      ThemeMode.values.singleWhere(
        (element) {
          try {
            if (Hive.box("app").get("theme_mode") == element.name) {
              return true;
            } else {
              return false;
            }
          } catch (e) {
            return false;
          }
        },
        orElse: () {
          return ThemeMode.system;
        },
      ),
    );
  }
}
