// ignore_for_file: non_constant_identifier_names

import 'dart:async';

import 'package:web_template/scheme/scheme.dart';
import 'package:hive_flutter/hive_flutter.dart';

class DatabaseLib {
  late Box box_app;
  late Box box_accounts;
  late Box box_dynamic;

  bool is_init = false;
  DatabaseLib();

  Future<void> ensureInitialized() async {
    if (is_init) {
      return;
    }
    await Hive.initFlutter();

    box_app = await Hive.openBox("app");
    box_accounts = await Hive.openBox("accounts");
    box_dynamic = await Hive.openBox("dynamic");
    is_init = true;
  }
}

class Database {
  final DatabaseLib databaseLib = DatabaseLib();
  Database();
  Future<void> ensureInitialized() async {
    await databaseLib.ensureInitialized();
  }

  List<AccountData> getAccounts() {
    dynamic raw_accounts = databaseLib.box_accounts.get("accounts", defaultValue: []);
    if (raw_accounts is List == false) {
      return [];
    }
    return (raw_accounts as List).whereType<Map>().map((e) => AccountData(e)).toList();
  }

  Future<void> deleteAccount({
    required List<AccountData> accountDatas,
  }) async {
    await databaseLib.box_accounts.put("accounts", accountDatas.map((e) => e.toJson()).toList());
  }
}
