import 'package:web_template/web_template.dart';
import 'package:web_template/app/app_core.dart';
import 'package:flutter/material.dart';
import 'package:general_lib_flutter/general_lib_flutter_core.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  AppCore appCore = AppCore();
  await appCore.ensureInitialized();

  runApp(MyApp(
    appCore: appCore,
  ));
}

class MyApp extends StatefulWidget {
  final AppCore appCore;
  const MyApp({
    super.key,
    required this.appCore,
  });

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return GeneralLibFlutterAppMain(
      theme_notifier: widget.appCore.themeModeNotifier,
      builder: (ThemeMode themeMode, ThemeData lightTheme, ThemeData darkTheme) {
        return MaterialApp(
          debugShowCheckedModeBanner: false,
          theme: lightTheme,
          darkTheme: darkTheme,
          themeMode: themeMode,
          home: MyHomePage(
            appCore: widget.appCore,
          ),
        );
      },
    );
  }
}
