// ignore_for_file: non_constant_identifier_names

import 'package:web_template/app/app_core.dart';
import 'package:web_template/page/landing/landing.dart';

import 'package:web_template/scheme/scheme.dart';
import 'package:flutter/material.dart';
import 'package:general_lib_flutter/general_lib_flutter_core.dart';
// ignore: unused_import
import 'package:hive/hive.dart';

class MyHomePage extends StatefulWidget {
  final AppCore appCore;

  const MyHomePage({super.key, required this.appCore});

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  String loading_text = "ini application";
  @override
  void initState() {
    super.initState();

    WidgetsBinding.instance.addPostFrameCallback((Duration duration) async {
      await task();
    });
  }

  @override
  void dispose() {
    super.dispose();
  }

  Future<void> task() async {
    Future(() async {
      setState(() {
        loading_text = "Get Local Accounts";
      });
      List<AccountData> accountDatas = widget.appCore.database.getAccounts();
      setState(() {
        loading_text = "Start Search Default Accounts";
      });

      for (var i = 0; i < accountDatas.length; i++) {
        AccountData accountData = accountDatas[i];
        if (accountData.is_default == true) {}
      }
      setState(() {
        loading_text = "Start Search Accounts Login";
      });

      context.navigator().pushReplacement(
        MaterialPageRoute(
          builder: (context) {
            return LandingPage(
              appCore: widget.appCore,
            );
          },
        ),
      );
    });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            CircularProgressIndicator(
              color: context.theme.indicatorColor,
            ),
            const SizedBox(
              height: 20,
            ),
            Text(
              loading_text,
            ),
          ],
        ),
      ),
    );
  }
}
